<?php
/*
Globel Administrator Library File for wordpress
*/
// Exit if file accessed directly ///
global $GBLCOM, $GBLMNUORDER;
defined('GBL_ADMIN_RUNNING_STATE') or die('Forbidden Includes Function For file: '.pathinfo(__FILE__, PATHINFO_FILENAME));
///////////////////////////////////////

function GBL_ADMIN_WRAP_ACCORDION($HTMLCONTENTS, $GBLCOMNAME)// as array
{
global $GBLCOM;
$ACCORDION = array_fill(0, 50, "");
$ACCORDION[0] = "ACCORDION"; // if not set below
$ACCORDION[1] = "checked";
if(isset($GBLCOM[$GBLCOMNAME])){$ACCORDION = explode(",",$GBLCOM[$GBLCOMNAME]);}
$wrapcount = 1;
$name = '';
$featurename = '';
$ACCcond = '';
$wrapped = "\n".'<!-- Start Accordion Wrapper -->'."\n";
$wrapped .= '<div class="accordion vertical">';
$wrapped .= '<ul>';

foreach ($HTMLCONTENTS as $key => $item)
	{
	$featurename = $key;
	
	$name = 'ACCORDION'.$wrapcount;
	$ACCcond = $ACCORDION[$wrapcount];
	$wrapped .= '<li>';
	$wrapped .= '<input type="checkbox" id="'.$name.'" name="'.$name.'" value="checked"'.$ACCcond.'/>'; //
	$wrapped .= '<label for="'.$name.'">'.$featurename.'</label>';
	$wrapped .= '<div class="content">';
	$wrapped .= $item;
	$wrapped .= '</div>';
	$wrapped .= '</li>';
	
	$wrapcount++;
	}
$wrapped .= '</ul>';
$wrapped .= "\n".'<!-- End Accordion Wrapper -->'."\n";
return $wrapped;
}

/**
 * Minifies stylesheet definitions
 *
 * @param 	string	$FILE	Stylesheet definitions as string
 * @return 	string		Minified stylesheet definitions
 * @author 		Joe Scylla <joe.scylla@gmail.com>
 * @copyright 	2008 Joe Scylla <joe.scylla@gmail.com>
 * Modified for Globel
 */
function GBL_ADMIN_CONDENSE_CSS($FILE)
{
$FILE = trim($FILE);
$FILE = str_replace("\r\n", "\n", $FILE);
$search = array("/\/\*[\d\D]*?\*\/|\t+/", "/\s+/", "/\}\s+/");
$replace = array(null, " ", "}\n");
$FILE = preg_replace($search, $replace, $FILE);
$search = array("/\\;\s/", "/\s*\{\\s*/", "/\\:\s+\\#/", "/,\s+/i", "/\\:\s+\\\'/i", "/\\:\s+([0-9A-Z\-]+)/i");
$replace = array(";", "{", ":#", ",", ":\'", ":$1");
$FILE = preg_replace($search, $replace, $FILE);
$FILE = str_replace("\n", null, $FILE);
return $FILE;
}

function GBL_ADMIN_MAKE_CHECK_DIR($target)
{
/**
 * Wordpress contributed Recursive directory creation based on full path.
 * Will attempt to set permissions on folders.
 * Was Wordpress @since 2.0.1 from
 * @param string $target Full path to attempt to create.
 * @return bool Whether the path was created. True if path already exists.
 * Modded for Globel Library .........
 */
// From php.net/mkdir plus user contributed notes.
$target = str_replace( '//', '/', $target );

/*
 * Safe mode fails with a trailing slash under certain PHP versions.
 * Use rtrim() instead of untrailingslashit to avoid formatting.php dependency.
 */
$target = rtrim($target, '/');
if (empty($target)){$target = '/';}


if ((file_exists($target)) && (is_dir($target))){return true;}
	//return @is_dir( $target );

// We need to find the permissions of the parent folder that exists and inherit that.
$target_parent = dirname( $target );
while ('.' != $target_parent && ! is_dir($target_parent)){$target_parent = dirname($target_parent);}

// Get the permission bits.
if ($stat = @stat($target_parent)){$dir_perms = $stat['mode'] & 0007777;} else{$dir_perms = 0777;}

if (@mkdir($target,$dir_perms,true)){
	/*
	 * If a umask is set that modifies $dir_perms, we'll have to re-set
	 * the $dir_perms correctly with chmod()
	 */
	if ($dir_perms != ($dir_perms & ~umask()))
		{
		$folder_parts = explode('/',substr($target,strlen($target_parent)+1));
		for ($i = 1, $c = count($folder_parts); $i <= $c; $i++)
			{
			@chmod($target_parent.'/'.implode('/',array_slice($folder_parts,0,$i)),$dir_perms);
			}
		}
	return true;
}
return false;
}

function GBL_ADMIN_CREATE_ADR($NAME, $DEFVALUE, $SEGMENTS = NULL)
{
$elements = 51;
$division = '||DIV||';
if ($DEFVALUE == ""){$DEFVALUE = NULL;}
if (($SEGMENTS == "") || ($SEGMENTS <= "0")){$SEGMENTS = "1";}
if (($SEGMENTS > "6")){$SEGMENTS = "6";}
if ($NAME == ""){$NAME = "HEADER";}
if (($SEGMENTS == "1") || ($SEGMENTS == NULL))
	{
	$ADR = array_fill(0, $elements, $DEFVALUE);
	$ADR[0] = $NAME;
	$ADR[$elements] = $elements;
	return $ADR;
	}
elseif (($SEGMENTS > 1) && ($SEGMENTS <= 6))
	{
	$expandelements = $elements * $SEGMENTS;
	$ADR = array_fill(0, $expandelements+1, $DEFVALUE);
	$ADR[0] = $NAME;
	if(isset($ADR[$elements])){$ADR[$elements] = $division;}
	if(isset($ADR[$elements*2])){$ADR[$elements*2] = $division;}
	if(isset($ADR[$elements*3])){$ADR[$elements*3] = $division;}
	if(isset($ADR[$elements*4])){$ADR[$elements*4] = $division;}
	if(isset($ADR[$elements*5])){$ADR[$elements*5] = $division;}
	$ADR[$expandelements] = $expandelements;
	return $ADR;
	}
else {print "too many segments";}
/*
PRED FIXED LINES
[0] => CAT (ALWAYS THE HEADER)
[51] => ||DIV|| (FIXED)
[102] => ||DIV|| (FIXED)
[153] => ||DIV|| (FIXED)
[204] => ||DIV|| (FIXED)
[255] => ||DIV|| (FIXED)
[306] => 306 (LAST TOTAL)
*/
return false;
}

function GBL_ADMIN_SAVE_ADR($FILE)
{
global $GBLCOM;
$newlines = "";
$GBLCOM['GBL_ADMIN_ADR_LINES'] = str_replace(array("\n", "\t", "\r"), '', $GBLCOM['GBL_ADMIN_ADR_LINES']);
foreach ($GBLCOM['GBL_ADMIN_ADR_LINES'] as $line)
	{
	// ALWAYS INCLUDE HEADER FIRST
	if ($line != "")
		{
		$newlines .= implode($line, ",")."\n";
		}
	}
///$newlines = str_replace( "\n\n", "\n",$newlines);
GBL_SAVE_FILE_CONTENTS($FILE, $newlines);
}

function GBL_ADMIN_FETCH_ADR($FILE,$RETURNLINES = null)
{
global $GBLCOM;
$filecontent = "";
$filelines = "";
$GBLCOM['GBL_ADMIN_ADR_LINES'] = null;
if ($RETURNLINES == ""){$RETURNLINES = false;}
if(file_exists($FILE))
	{
	$filecontent = GBL_OPEN_FILE_CONTENTS($FILE);
	if (($filecontent != "") || ($filecontent != null))
		{
		$filelines = explode("\n", $filecontent);
		if ($RETURNLINES){$GBLCOM['GBL_ADMIN_ADR_LINES'] = $filelines;}
		else
			{
			foreach ($filelines as $line){if ($line != ""){$GBLCOM['GBL_ADMIN_ADR_LINES'][] = explode(",", $line);}}
			return true;
			}
		}
	else {return false;}
	}
else {return false;}
}

function GBL_OPEN_FILE_CONTENTS($FILE)
{
global $GBLCOM;
if (file_exists(GBL_ADMIN_INCLUDES_DIR."/encoder.ftr.php")){include_once(GBL_ADMIN_INCLUDES_DIR."/encoder.ftr.php");}
$MYCONTENT = "";
$MYCONTENT = file_get_contents($FILE);
if ((isset($GBLCOM['GBL_ADMIN_ENCODE_DATA'])) && (isset($GBLCOM['GBL_ADMIN_ENCODE_SALT'])))
	{
	if (function_exists('GBL_ADMIN_DECODE'))
		{
		$MYCONTENT = GBL_ADMIN_DECODE($MYCONTENT,$GBLCOM['GBL_ADMIN_ENCODE_SALT']);
		}
	}
return $MYCONTENT;
}

function GBL_SAVE_FILE_CONTENTS($FILE,$CONTENT)
{
global $GBLCOM;
if (file_exists(GBL_ADMIN_INCLUDES_DIR."/encoder.ftr.php")){include_once(GBL_ADMIN_INCLUDES_DIR."/encoder.ftr.php");}
$MYCONTENT = $CONTENT;

// CHANGE FOR UNIVERSAL AND NOT JUST WP
$GBL_ADMIN_KEEP_TRACK = '';
$MyKey = 'hRF54pF';
//*********************** $DIR CHECK leading slash and double **********************//
//CHECK FOR AND/OR CREATE REQUIRED FILES
$DIR = dirname($FILE);
if (!file_exists($DIR.'/index.php')){GBL_CHECKCREATE_STOPFILE($DIR.'/index.php');}
//********************************************************
if(isset($_REQUEST['_wpnonce']))
	{
	$GBL_ADMIN_KEEP_TRACK = $_REQUEST['_wpnonce']; // no sanitisation needed as per wordpress email
	if (wp_verify_nonce($GBL_ADMIN_KEEP_TRACK, $MyKey))
		{
		$FILE = str_replace('//', '/',$FILE);
		if ((isset($GBLCOM['GBL_ADMIN_ENCODE_DATA'])) && (isset($GBLCOM['GBL_ADMIN_ENCODE_SALT'])))
			{
			if (($GBLCOM['GBL_ADMIN_ENCODE_DATA'] == "on") && ($GBLCOM['GBL_ADMIN_ENCODE_SALT'] != ""))
				{
				if (function_exists('GBL_ADMIN_ENCODE'))
					{
					$MYCONTENT = GBL_ADMIN_ENCODE($MYCONTENT,$GBLCOM['GBL_ADMIN_ENCODE_SALT']);
					}
				}
			}
		if (file_put_contents($FILE, $MYCONTENT,  LOCK_EX | LOCK_SH)){return true;}
		else {return false;}
		}
	else 
		{
		wp_die('Invalid nonce specified', GBL_ADMIN_APP_NAME_SHORT);
		return false;
		}
	}
}


function GBL_ADMIN_CONTROL_INSERTS($URL)
{
global $GBLCOM;
$value = '';
if (GBL_ADMIN_MYNAME == "GlobelWP")
	{
	if ($URL != "")
		{
		$value = $URL."&_wpnonce=".$GBLCOM['GBL_ADMIN_KEEP_TRACK']."&page=".GBL_WORDPRESS_ADMIN.'&';
		}
	else
		{
		$value = "\n".'<!-- START HIDE FIELDS -->'."\n";
		$value .= '<input value="'.$GBLCOM['GBL_ADMIN_TAB'].'" name="gbltab" type="hidden">'."\n";
		$value .= '<input value="'.$GBLCOM['GBL_ADMIN_PAGE'].'" name="gblpage" type="hidden">'."\n";
		 // INSERT FOR WORDPRESS
		$value .= '<input value="'.GBL_WORDPRESS_ADMIN.'" name="page" type="hidden">'."\n";
		$value .= '<input value="'.$GBLCOM['GBL_ADMIN_KEEP_TRACK'].'" name="_wpnonce" type="hidden">'."\n";
		$value .= '<!-- END HIDE FIELDS -->'."\n";
		}
	}
else {$value = $URL;}
return $value;
}

/*
function GBL_SANITISE_EMAIL($TXT)
{
$TXT = sanitize_email($TXT);
return $TXT;
}

function GBL_SANITISE_TEXT($TXT)
{
$TXT = sanitize_text_field($TXT);
return $TXT;
}

function sanitize_text_field_ONLY($TXT)
{
$TXT = strip_tags($TXT); // strip out any HTML
$TXT = preg_replace('/\s+/S', " ", $TXT); //replace all multiple white-spaces, tabs and new-lines
$TXT = preg_replace("/[^a-zA-Z]/", "", $TXT); /// allow only chars
return $TXT;
}
*/
function GBL_SANITISE_NUMBER_ONLY($TXT) 
{
$output ="not again"; 
if ( is_numeric($TXT)){$output=intval( $TXT);}
else {
//add_action( 'admin_notices', 'is not a number!' );
//_e( 'is not a number!' );
}
return $output;
}

function GBL_SANITISE_PASSWORD($TXT)
{
$TXT = strip_tags($TXT); // strip out any HTML
$TXT = preg_replace('/\s+/S', " ", $TXT); //replace all multiple white-spaces, tabs and new-lines
$TXT = preg_replace("/[^a-zA-Z0-9]/", "", $TXT); /// allow only chars
return $TXT;
}

function GBL_ADMIN_SENDMAIL($FROM,$TO,$SUBJECT,$MESSAGE,$HEADERS = null)
{
global $GBLCOM;
IF(EMPTY($FROM)) {return;}
IF(EMPTY($SUBJECT)) {return;}
$HEADERS[] = 'From: '.$SUBJECT.' <'.$FROM.'>';

$FROM =	sanitize_email($FROM);
$TO = sanitize_email($TO);
$MESSAGE = sanitize_text_field($MESSAGE);
//$HEADERS = sanitize_text_field($HEADERS);

if(GBL_ADMIN_MYNAME == 'GlobelWP') {
remove_filter('wp_mail_from', 'bp_core_email_from_address_filter' );
remove_filter('wp_mail_from_name', 'bp_core_email_from_name_filter');
wp_mail($TO, $SUBJECT, $MESSAGE, $HEADERS, '');} else {
mail($TO, $SUBJECT, $MESSAGE, $HEADERS, '');} 
///print "email sent";

}

function GBL_SET_BOOT_PAGE()
{
global $GBLCOM, $GBLMNUORDER;
if ($GBLCOM['GBL_ADMIN_ACT'] == "gblsaveasfavouritepage")
	{
	$GBLCOM['GBL_ADMIN_BOOT_PAGE'] = $GBLCOM['GBL_ADMIN_PAGE'];
	$GBLCOM['GBL_ADMIN_BOOT_TAB'] = $GBLCOM['GBL_ADMIN_TAB'];
	GBL_SAVE_COMFILE($GBLCOM,"","","GBL_ADMIN_APP_NAME",GBL_ADMIN_APP_NAME,"GBLCOM",GBL_ADMIN_DATA_DIR."/");
	}

	if (($GBLCOM['GBL_ADMIN_TAB'] == $GBLCOM['GBL_ADMIN_BOOT_TAB']) && ($GBLCOM['GBL_ADMIN_PAGE'] == ""))
	{$GBLCOM['GBL_ADMIN_PAGE'] = $GBLCOM['GBL_ADMIN_BOOT_PAGE']; $GBLCOM['GBL_ADMIN_ISBOOTPAGE'] = True;}
	elseif (($GBLCOM['GBL_ADMIN_TAB'] == "") && ($GBLCOM['GBL_ADMIN_PAGE'] == ""))
	{$GBLCOM['GBL_ADMIN_PAGE'] = $GBLCOM['GBL_ADMIN_BOOT_PAGE']; $GBLCOM['GBL_ADMIN_TAB'] = $GBLCOM['GBL_ADMIN_BOOT_TAB']; $GBLCOM['GBL_ADMIN_ISBOOTPAGE'] = True;}

	if (($GBLCOM['GBL_ADMIN_PAGE'] == $GBLCOM['GBL_ADMIN_BOOT_PAGE']) && ($GBLCOM['GBL_ADMIN_BOOT_PAGE'] != "") &&
		($GBLCOM['GBL_ADMIN_BOOT_TAB'] == $GBLCOM['GBL_ADMIN_TAB']) && ($GBLCOM['GBL_ADMIN_TAB'] != "")){$GBLCOM['GBL_ADMIN_ISBOOTPAGE'] = True;}
	elseif (($GBLCOM['GBL_ADMIN_BOOT_TAB'] == $GBLCOM['GBL_ADMIN_TAB']) && ($GBLCOM['GBL_ADMIN_BOOT_PAGE'] == "")){$GBLCOM['GBL_ADMIN_ISBOOTPAGE'] = True;}
	else {$GBLCOM['GBL_ADMIN_ISBOOTPAGE'] = false;}
}


Function GBL_GET_SCRIPT_HEADER()
{
$RETURN_OUTPUT = "";
$RETURN_OUTPUT .= <<<RETURN_OUTPUT
<?php
//Globel Administrator Library File
// Exit if file accessed directly
global \$GBLCOM;
defined('GBL_ADMIN_RUNNING_STATE') or die('Forbidden Includes Function For file: '.pathinfo(__FILE__, PATHINFO_FILENAME));
////////////////////////////////////
RETURN_OUTPUT;
return $RETURN_OUTPUT;
}

Function GBL_GET_SCRIPT_FOOTER()
{
$RETURN_OUTPUT = "";
$RETURN_OUTPUT .= <<<RETURN_OUTPUT


?>
RETURN_OUTPUT;
return $RETURN_OUTPUT;
}

/****************************** LUKE BUILD ******************************
BASIC - GBL_CREATE_HTML(type=, name=, value=, style=, placeholder=, min=, max=)
-------------------------- TYPES --------------------------
[MIN] TEXTAREA - GBL_CREATE_HTML('textarea', 'example_1', '', '', '', '', '')
[MAX] TEXTAREA - GBL_CREATE_HTML('textarea', 'example_1', 'default value', 'background: blue;', 'example 1')

[MIN] TEXT - GBL_CREATE_HTML('text', 'example_2', '', '', '', '', '')
[MAX] TEXT - GBL_CREATE_HTML('text', 'example_2', 'default value', 'background: blue;', 'example 2')

[MIN] NUMBER - GBL_CREATE_HTML('number', 'example_3', '', '', '', '', '')
[MAX] NUMBER - GBL_CREATE_HTML('number', 'example_3', 'default value', 'style', 'example 3', 'min value', 'max value')

[MIN] SELECT - GBL_CREATE_HTML('select', 'example_4', '', '', '', '', '')
[MAX] SELECT - GBL_CREATE_HTML('select', 'example_4', array('option 1', 'option 2', 'option 3'), 'style', 'example 4')
GBL_CREATE_HTML('select', 'example_4', 'asas', 'min=gyugh max=ji plasc=oo');
GBL_CREATE_HTML('text', 'example_4', 'asas', "", array('option 1', 'option 2', 'option 3'), 'style', 'example 4'));
## KEY ##
[MIN] - Minimum keys required for the f ield to work.
[MAX] - All the additional fields are listed after the [MIN] keys that are optional to the user.
*/
function GBL_CREATE_HTML($TYPE, $NAME, $VALUE, $ADDITIONAL, $SELECTED = null) {
	
	$DEFAULTOUT = "";
	
	if($TYPE !== ''&$NAME !== ''&!is_array($ADDITIONAL)&!is_array($TYPE)&!is_array($NAME)) {
		if(is_array($VALUE)) {
			switch($TYPE) {
				case 'select':
				foreach($VALUE as $DEFAULTDATA) 
					{
					if ($DEFAULTDATA == $SELECTED)
						{
						$DEFAULTOUT .= '<option selected>'.$DEFAULTDATA.'</option>'; 	
							
						}
					else {$DEFAULTOUT .= '<option>'.$DEFAULTDATA.'</option>'; }
					}
				return '<select name="'.$NAME.'" '.$ADDITIONAL.'>'.$DEFAULTOUT.'</select>';
			}
		} else {
			switch($TYPE) {
				case in_array($TYPE, array('button', 'checkbox', 'color', 'date', 'datetime-local', 'email', 'file', 'hidden', 'image', 'month', 'number', 'password', 'radio', 'range', 'reset', 'search', 'submit', 'tel', 'text', 'time', 'url', 'week')):
				return '<input type="'.$TYPE.'" name="'.$NAME.'" value="'.$VALUE.'" '.$ADDITIONAL.'>';
				
				case 'textarea':
				return '<textarea name="'.$NAME.'" '.$ADDITIONAL.'>'.$VALUE.'</textarea>';
			}
		}
		return 'No field with name: <b>'.$TYPE.'</b> found.';
	} else {
		return '$TYPE and $NAME cannot be empty and cannot be array/s.';
	}
}

function GBL_SAVE_COMFILE($COMARRAY,$FKEY,$FVAL,$LKEY,$LVAL,$ANAME,$FDIR)
{
/*
$COMARRAY = ARRAY TO BUILD
$FKEY = FIRST KEY TO ADD TO ARRAY
$FVAL = FIRST VALUE TO ADD TO ARRAY
$LKEY = LAST KEY TO ADD TO ARRAY
$LVAL = FIRST VALUE TO ADD TO ARRAY
$ANAME = ARRAY NAME WILL ALSO BE ARRAY FILE NAME
$FDIR = FILE DIR TO SAVE TO
*/
global $GBLCOM;
$success = false;
$arraytext = ""; 
$COMFILE = "";
$HEADER = GBL_GET_SCRIPT_HEADER();
if (empty($COMARRAY)){$COMARRAY = array("EMPTY_NAME" => "NULL");}// IF NULL CREATE EMPTY ARRAY#

IF ($FKEY != ""){$arraytext .= '"'.$FKEY.'" => "'.$FVAL.'",'."\n";}
foreach($COMARRAY as $key => $value)
	{
	if (($key != $FKEY) && ($key != $LKEY))
		{
		if (!(strpos($GBLCOM['GBL_ADMIN_GBLCOM_IGNORE'], $key)))
			{
			$arraytext .= '"'.$key.'" => "'.$value.'",'."\n";

			}
		}
	}
IF ($LKEY != ""){$arraytext .= '"'.$LKEY.'" => "'.$LVAL.'"';}
else {$arraytext .= '"LASTKEY" => "NULL"';}

$COMFILE.= <<<COMFILE
$HEADER

\$$ANAME = array(
$arraytext
);
?>
COMFILE;
if ($GBLCOM["GBL_ADMIN_SAVE_BACKUPS"] == "yes"){GBL_BACKUP($FDIR."/",$ANAME.".PHP");}

if (GBL_SAVE_FILE_CONTENTS($FDIR."/".$ANAME.'.PHP', $COMFILE)){$success = true;}else {$success = false;};
return $success;
}

function GBL_NOTIFICATION($message, $backgroundcolor, $textcolor, $timefade)
{
$message = str_replace('\'', '', $message);
if($timefade !== 0) 
 {
 $timefade = $timefade * 1000;
return <<<data
<script>
jQuery("#Notification").html("<p style='background-color: $backgroundcolor; color: $textcolor;'><b>$message</b></p>").fadeIn('slow').animate({opacity: 1.0}, $timefade).fadeOut('slow');
</script>
data;
 } 
else {
return <<<data
<script>
jQuery("#Notification").html('<p style="background-color: $backgroundcolor; color: $textcolor;"><b>$message</b></p>');
</script>
data;
 }
}

function GBL_LOCAL_GET_SIDENAV_TABS($selectedTAB,$selectedPAGE,$commonlink)
{
global $GBLCOM, $GBLMNUORDER;
if ($selectedTAB == "dashboard"){$sideNav = ""; return $sideNav;} /// escape if dashboard
else{$buildMNU = false;}

//if (FILE_EXISTS(GBL_ADMIN_USER_PERMISSIONS_DIR."/".$GBLCOM['GBL_WORDPRESS_USER']))
//{include GBL_ADMIN_USER_PERMISSIONS_DIR."/".$GBLCOM['GBL_WORDPRESS_USER']; }

$scandir = GBL_ADMIN_EXTENSIONS_DIR."/".$selectedTAB."/";
$files = scandir($scandir);
########################################################
if (file_exists($scandir."GBLMNUORDER.LIB.PHP")){include_once($scandir."GBLMNUORDER.LIB.PHP");}
else{$GBLMNUORDER["temp_fix"] = "NULL";$buildMNU = true;}
// remove foreach and do search...........
foreach ($files as $fileinfo)
	{
	//$count = 0;
    if ($fileinfo != "." && $fileinfo != "..")
    	{
		if ((strpos($fileinfo, ".mnu.php") !== false) || (strpos($fileinfo, ".hdr.php") !== false) || (strpos($fileinfo, ".ftr.php") !== false))
			{
			$fileinfo = str_replace(".php","",$fileinfo);
			if ((is_array($GBLMNUORDER)) && (!in_array($fileinfo,$GBLMNUORDER)))
				{	
				$GBLMNUORDER[] = $fileinfo;
				$buildMNU = true;
				}
			}	
		}
	}
$builtmnu = "";
$firstpage = "";

if ((is_array($GBLMNUORDER)))
	{
	ksort($GBLMNUORDER,SORT_REGULAR);}
$Lastkey = GBL_GET_LASTKEY($GBLMNUORDER);
$sideNav = '<ul id="SideNavMenu" class="SideNavMenu">';
//$sideNav .= '<li><BR><BR><BR><BR><HR></li>';
$sideNav .= '<div class="menuadvertisement"><BR><BR><BR><BR></div><HR>';


$IMAGESTYLE = "\n".'<style type="text/css">'."\n";

foreach($GBLMNUORDER as $key => $value)
	{
	if (file_exists($scandir.$value.".php"))
		{
		if ((strpos($value, ".mnu") !== false) || (strpos($value, ".ftr") !== false))
			{
			$builtmnu .= '"'.$key.'" => "'.$value.'",'."\n";
			$value = str_replace(".ftr","",$value);
			$value = str_replace(".mnu","",$value);
			$Tab = ucwords($selectedTAB);
			$Arrayname = $value;//
			$words = str_replace("_"," ",$value);
			$image = $scandir.$value.".png";
			
			if(isset(${"$Tab"}))
				{
				$TabArray = ${"$Tab"}; 
				if(isset($TabArray[$Arrayname]))
					{
					
					$Perms = $TabArray[$Arrayname];
					}
					// Notices perms not set for page etc.
				}
			else {$Perms = "1";}
			
			if ($Perms == "1")
				{
				if (FILE_EXISTS($image))
					{
					$GBL_MY_IMAGE = GBL_ADMIN_BASEURI_MYPATH."/Extension/".basename($scandir)."/".$value.".png";
					$imageinsert = '<img alt="'.$value.'" height="16" width="16" style="float: left" src="'.$GBL_MY_IMAGE.'" />';
					$IMAGESTYLE .= 'li.'.$value.' {';
					$IMAGESTYLE .= 'background: url(‘'.$GBL_MY_IMAGE.'’) no-repeat left top; height: 16px; padding-left: 1px; padding-top: 1px;}'."\n";

					}
				else 
					{
					$GBL_MY_IMAGE = GBL_ADMIN_BASEURI_MYPATH."/Extension/_includes/default.png";
					$imageinsert = '<img alt="default" height="16" width="16" style="float: left" src="'.$GBL_MY_IMAGE.'" />';
					$IMAGESTYLE .= 'li.linedefault {';
					$IMAGESTYLE .= 'background: url(‘'.$GBL_MY_IMAGE.'’) no-repeat left top; height: 1px; padding-left: 1px; padding-top: 1px;}'."\n";
					}
				$sideNav .= '     <li id=”linedefault”>'.'<a class=”linedefault” href="'.$commonlink.'&gblpage='.$value.'">'.ucwords($words).'</a></li>'."\n";
				/**/
				
				}
			}
		elseif (strpos($value, ".hdr") !== false)
			{
			$builtmnu .= '"'.$key.'" => "'.$value.'",'."\n";
			$value = str_replace(".hdr","",$value);
			$words = str_replace("_"," ",$value);
			$sideNav .= '     <li><BR><div style="color: #39F; font-weight: bold; text-align:center;">'.ucwords($words).'</div><BR></li>'."\n";
			}
			
		}
		else {unset($GBLMNUORDER[$key]); $buildMNU = true;}
	}
if(isset($GBLCOM["GBL_ADMIN_BOOT_MENU"])){$sideNav .= $GBLCOM["GBL_ADMIN_BOOT_MENU"];}

if ($GBLCOM['GBL_ADMIN_TAB'] != "dashboard")
	{
	$sideNav .= '<li><BR><div style="color: #39F; font-weight: bold; text-align:center;">'.'Version: '.GBL_ADMIN_VERSION;
	$sideNav .= '</div><BR></li>'."\n ";// 
	}
$sideNav .= '</ul>';


$IMAGESTYLE .= '</style>'."\n";

//if ($buildMNU){GBL_BUILD_MENU($builtmnu,$scandir);}
$find = '&gblpage='.$selectedPAGE.'">';
$replace = '&gblpage='.$selectedPAGE.'" class="active">';
$sideNav = str_replace ($find,$replace,$sideNav);

return $IMAGESTYLE.$sideNav;
}

function GBL_ADMIN_ADDTO_GBLCOM_IGNORE($IGNORE)
{
global $GBLCOM;
if (strpos($GBLCOM['GBL_ADMIN_GBLCOM_IGNORE'], $IGNORE) === false){$GBLCOM['GBL_ADMIN_GBLCOM_IGNORE'] .= ','.$IGNORE; return true;}
else {return false;}
}

function GBL_BUILD_MENU($builtmnu,$DIR)
{
global $GBLCOM;
$PHPfile = "";
$PHPfile.= <<<PHPFILE1
<?php
//Globel Administrator Library File
// Exit if file accessed directly
global \$GBLCOM, \$GBLMNUORDER;
global \$GBLCOM;
defined('GBL_ADMIN_RUNNING_STATE') or die('Forbidden Includes Function For file: '.pathinfo(__FILE__, PATHINFO_FILENAME));
////////////////////////////////////
\$GBLMNUORDER = array(
$builtmnu
);
?>

PHPFILE1;
if ($GBLCOM["GBL_ADMIN_SAVE_BACKUPS"] == "yes"){GBL_BACKUP($DIR,"GBLMNUORDER.LIB.PHP");}
GBL_SAVE_FILE_CONTENTS($DIR."GBLMNUORDER.LIB.PHP", $PHPfile);
}

# Highlight PAGE

function GBL_GET_LASTKEY($gblarray){if ((is_array($gblarray))){end($gblarray);return key($gblarray);}}
#################################################################

function GBL_BACKUP($GBL_PATH, $GBL_FILE)
{
global $GBLCOM;
$GBL_SRCFILE = $GBL_PATH."/".$GBL_FILE;

if ((FILE_EXISTS($GBL_SRCFILE)) && ($GBLCOM['GBL_ADMIN_SAVE_BACKUPS'] == "yes"))
	{
	$i = 1;
	while ($i <= 100)
		{
		if (strlen($i) == 1){$number = "00".$i;}
		elseif (strlen($i) == 2){$number = "0".$i;}
		$GBL_DESTINATION = $GBL_PATH."/".$GBL_FILE.".BK".$number;
		if (FILE_EXISTS($GBL_DESTINATION) == false){copy($GBL_SRCFILE, $GBL_DESTINATION); break;}
		$i++;
		}
	}

}

function GBL_CHECKCREATE_STOPFILE($FILE)
{
$FILE = str_replace('//', '/',$FILE);
$PHPFILE2 = "";
$HEADER = GBL_GET_SCRIPT_HEADER();
$PHPFILE2.= <<<PHPFILE2
$HEADER


?>
PHPFILE2;
file_put_contents($FILE, $PHPFILE2);
//if (){return true;}
//else {return false;}
//GBL_SAVE_FILE_CONTENTS($FILE, $PHPFILE2);

}

#################################################################
function GBL_LOCAL_GET_TOPNAV_TABS($commonlink)
{
global $GBLCOM;

$scandir = GBL_ADMIN_EXTENSIONS_DIR."/";
$dirs = scandir($scandir);
$mainNav = '<ul id="TopNavMenu">'; //mainNav
if ($GBLCOM["GBL_ADMIN_DASHBOARD"] == "on"){$mainNav .= '     <li><a href="'.$commonlink.'&gbltab=dashboard">DASHBOARD</a></li>'."\n";}
$GBL_MY_IMAGE = "";

//if (FILE_EXISTS(GBL_ADMIN_USER_PERMISSIONS_DIR."/".$GBLCOM['GBL_WORDPRESS_USER']))
//{include GBL_ADMIN_USER_PERMISSIONS_DIR."/".$GBLCOM['GBL_WORDPRESS_USER']; }

foreach ($dirs as $fileinfo)
	{
    if (is_dir($scandir.$fileinfo) && $fileinfo != "." && $fileinfo != ".." && strpos($fileinfo, "_") === false)
    	{
		$Arrayname = ucwords($fileinfo);
		if(isset(${"$Arrayname"})){$TabArray = ${"$Arrayname"}; $Perms = $TabArray[$Arrayname];} //
		else {$Perms = "1";}
		if ($Perms == "1")
			{
			$image = $scandir.$fileinfo.'/'.$fileinfo.".png";
			if (FILE_EXISTS($image))
				{
				$GBL_MY_IMAGE = GBL_ADMIN_BASEURI_MYPATH."/Extension/".$fileinfo."/".$fileinfo.".png";
				$imageinsert = '<img alt="'.$fileinfo.'" height="25" width="25" style="float: left" src="'.$GBL_MY_IMAGE.'" />';
				}else {$imageinsert = "";}
				
			$TABTitle = strtoupper(str_replace('-', ' ', $fileinfo));
			$mainNav .= '     <li>'.'<a href="'.$commonlink.'&gbltab='.$fileinfo.'">'.$imageinsert.' '.$TABTitle.'</a></li>'."\n";
			}
   		}
	}
$mainNav .= '</ul>';
# Highlight TAB
$selectedTAB = $GBLCOM['GBL_ADMIN_TAB']; 
$selectedPAGE = $GBLCOM['GBL_ADMIN_PAGE'];
if ($selectedTAB == ""){$selectedTAB = "dashboard";}
$find = '&gbltab='.$selectedTAB.'">';
$replace = '&gbltab='.$selectedTAB.'" class="active">';
$mainNav = str_replace ($find,$replace,$mainNav);

return $mainNav;
}
?>
